QT       += core gui
QT      +=widgets serialport
QT      +=network
    # for TCP-IP

TARGET  = APservice
#LIBS = -L../plugins

greaterThan(QT_MAJOR_VERSION, 4): QT += widgets

CONFIG += c++11
QMAKE_CXXFLAGS += -Wno-deprecated-copy

# You can make your code fail to compile if it uses deprecated APIs.
# In order to do so, uncomment the following line.
#DEFINES += QT_DISABLE_DEPRECATED_BEFORE=0x060000    # disables all the APIs deprecated before Qt 6.0.0


contains( CONFIG, PTU5 ) {
    # QMAKE_CC = ccache $$QMAKE_CC
    # QMAKE_CXX = ccache $$QMAKE_CXX
    QMAKE_CXXFLAGS += -std=c++11
    linux-clang {  QMAKE_CXXFLAGS += -Qunused-arguments   }
    CONFIG += link_pkgconfig
    PTU5BASEPATH = /opt/devel/ptu5
    ARCH = PTU5

    INCLUDEPATH += $$PTU5BASEPATH/qt/libs/deviceController/include/
    LIBS += -L$$PTU5BASEPATH/qt/libs/deviceController/library

    LIBS += -lCAslave
    LIBS += -lCAmaster
}

contains( CONFIG, PTU5_YOCTO ) {
    PTU5BASEPATH = /opt/devel/ptu5
    ARCH = PTU5

    LIBS += -lCAslave
    LIBS += -lCAmaster
}



SOURCES += \
    globVars.cpp \
    keypad.cpp \
    lib_template.cpp \
    main.cpp \
    mainwindow.cpp \
    tslib.cpp \
    win01_com.cpp \
    win02_home.cpp \
    win03_time.cpp \
    win04_stat.cpp \
    win05_doors.cpp \
    win06_prn.cpp \
    win07_coin.cpp \
    win08_mif.cpp \
    win09_gsm.cpp \
    win10_pay.cpp \
    win11_abr.cpp \
    win12_BL.cpp \
    win13_json.cpp \
    win14_mw.cpp \
    win15_bna.cpp \
    win16.cpp \
    win17.cpp \
    win18.cpp \
    win19.cpp \
    win20.cpp \
    win_template.cpp \
    datei.cpp

HEADERS += \
    globVars.h \
    guidefs.h \
    keypad.h \
    lib_template.h \
    mainwindow.h \
    stepList.h \
    tslib.h \
    versionHistory.txt \
    win01_com.h \
    win02_home.h \
    win03_time.h \
    win04_stat.h \
    win05_doors.h \
    win06_prn.h \
    win07_coin.h \
    win08_mif.h \
    win09_gsm.h \
    win10_pay.h \
    win11_abr.h \
    win12_BL.h \
    win13_json.h \
    win14_mw.h \
    win15_bna.h \
    win16.h \
    win17.h \
    win18.h \
    win19.h \
    win20.h \
    win_template.h \
    datei.h \
    plugin.h


OTHER_FILES += \
    generate-version.sh

CONFIG(DesktopLinux, DesktopLinux|PTU5):DEFINES += SYSTEM_DESKTOP_LINUX
CONFIG(PTU5,         DesktopLinux|PTU5):DEFINES += SYSTEM_PTU5

# Define how to create version.h
VERSION_H = $$PWD/version.h
version.output = $$PWD/version.h
version.commands = $$PWD/generate-version.sh $${ARCH} $${TARGET} $${VERSION_H}
version.depends = FORCE
version.input = VERSION_H
version.variable_out = HEADERS
QMAKE_EXTRA_COMPILERS += version
QMAKE_CLEAN += $${PWD}/version.h
