#ifndef KEYPAD_USED
#define KEYPAD_USED

#include <QObject>
#include <QTimer>
#include <QDebug>
#include <QWidget>
#include "tslib.h"
#include "stepList.h"
#include "plugin.h"
#include <QGroupBox>
#include <QPushButton>
#include <QGridLayout>
#include <QLineEdit>
#include <QLabel>
#include <QVBoxLayout>
#include <QGridLayout>

class T_keypad : public QWidget
{
    Q_OBJECT

    QGroupBox   *numPad;
    QLabel      *valueDisplay;
    QString     myValueString;      // used to display the entry in upper line
    QString     myReturnString;      // used to return the value

    QVBoxLayout *myMainLay;
    QGridLayout *mySubLayout;
    QLabel      *headline;

public:
    explicit T_keypad(QWidget *parent = nullptr);
    ~T_keypad();

    void show(void);
    void hide();
    void setText(QString headLine);

    void keysVisible(uint8_t visib);
        // visib=0: show *     1:show numbers    2: show * but allow visi-key


    QString getValueString(void);
    int32_t getValueDecimal(void);


private slots:
    void key0Clicked(void);
    void key1Clicked(void);
    void key2Clicked(void);
    void key3Clicked(void);
    void key4Clicked(void);
    void key5Clicked(void);
    void key6Clicked(void);
    void key7Clicked(void);
    void key8Clicked(void);
    void key9Clicked(void);

    void keyAcClicked(void);
    void keyBsClicked(void);

    void keyOkClicked(void);
    void keyCancelClicked(void);
    void keySeeEntryClicked(void);

signals:
    void keyEntryFinished(void);



};

#endif
