#ifndef MAINWINDOW_H
#define MAINWINDOW_H

#include <QMainWindow>
#include <QTimer>
#include <QGroupBox>
#include <QStyle>
#include <QVBoxLayout>
#include <QHBoxLayout>
#include <QGridLayout>
#include <QLabel>
#include <QDebug>
#include <QPushButton>
#include <QDialog>
#include <QWidget>
#include <QApplication>
#include <QObject>
#include <QDateTime>
#include <QDate>
#include <QTime>

#include <QPluginLoader>
#include <QDir>
#include "plugin.h"


//#include "stepList.h" // define all working chain steps here
#include "win01_com.h"
#include "win02_home.h"
#include "win03_time.h"
#include "win04_stat.h"
#include "win05_doors.h"
#include "win06_prn.h"
#include "win07_coin.h"
#include "win08_mif.h"
#include "win09_gsm.h"
#include "win10_pay.h"
#include "win11_abr.h"
#include "win12_BL.h"
#include "win13_json.h"
#include "win14_mw.h"
#include "win15_bna.h"
#include "win16.h"
#include "win17.h"
#include "win18.h"
#include "win19.h"
#include "win20.h"
//#include "win21.h"
//#include "win22.h"
//#include "win23.h"

//#include "lib_mifare.h"
//#include "lib_diary.h"
//#include "lib_config.h"


class MainWindow : public QMainWindow
{
    Q_OBJECT

    QPushButton *pBback;
    QPushButton *pBhome;
    QPushButton *pBforward;
    QGroupBox   *bigGroupbox;
//    QVBoxLayout *bigLayout;
    QHBoxLayout *bigLayout;
    QTimer      *timerChainCtrl;
    QTimer      *timerVendingTimeout;

    QGroupBox   *frame01;
    QGroupBox   *frame02;
    QGroupBox   *frame03;
    QGroupBox   *frame04;
    QGroupBox   *frame05;
    QGroupBox   *frame06;
    QGroupBox   *frame07;
    QGroupBox   *frame08;
    QGroupBox   *frame09;
    QGroupBox   *frame10;
    QGroupBox   *frame11;
    QGroupBox   *frame12;
    QGroupBox   *frame13;
    QGroupBox   *frame14;
    QGroupBox   *frame15;
    QGroupBox   *frame16;
    QGroupBox   *frame17;
    QGroupBox   *frame18;
    QGroupBox   *frame19;
    QGroupBox   *frame20;
    QGroupBox   *frame21;
    QGroupBox   *frame22;
    QGroupBox   *frame23;
    QGroupBox   *frame24;
    QGroupBox   *frame25;
    QGroupBox   *frame26;
    QGroupBox   *frame27;
    QGroupBox   *frame28;
    QGroupBox   *frame29;
    QGroupBox   *frame30;

    //T_winComPort    *myFenster01;
    T_win02         *myFenster02;
    T_win03         *myFenster03;
    T_win04         *myFenster04;
    T_win05         *myFenster05;
    T_win06         *myFenster06;
    T_win07         *myFenster07;
    T_win08         *myFenster08;
    T_win09         *myFenster09;
    T_win10         *myFenster10;
    T_win11         *myFenster11;
    T_win12         *myFenster12;
    T_win13         *myFenster13;
    T_win14         *myFenster14;
    T_win15         *myFenster15;
    T_win16         *myFenster16;
    T_win17         *myFenster17;
    T_win18         *myFenster18;
    T_win19         *myFenster19;
    T_win20         *myFenster20;
    /*
    T_win21         *myFenster21;
    T_win22         *myFenster22;
    T_win23         *myFenster23;
*/



    void HideAllWindows();
    void switchScreen(uint16_t winNr);
    char loadPlugIn(char lade1_entlade2);
    QDir plugInDir;
    void chainIni(void);
    //T_Mifare     *mifCard;
    //T_lib_diary  *diary;
    //T_lib_config *conf;


public:
    hwinf *HWaccess=nullptr;        // global pointer to plugin-class

    MainWindow(QWidget *parent = nullptr);
    ~MainWindow();

#define BACKBUTTON  1
#define HOMEBUTTON  2
#define FORWBUTTON  3
    void enableNaviButtons(uint8_t buttonNr, bool enabled);
    void enableNaviButtons(uint8_t switchBitwise);
    bool BLisRunning();

private slots:
    void chainControl();
    void vendingTimeout();

};




#endif // MAINWINDOW_H
