#ifndef WIN05_DOORS_H
#define WIN05_DOORS_H

#include <QVBoxLayout>
#include <QHBoxLayout>
#include <QGridLayout>
#include <QObject>
#include <QTimer>
#include <QDebug>
#include <QScrollBar>
#include <QPlainTextEdit>
#include <QComboBox>
#include <QLabel>
#include <QScrollArea>
#include <QSerialPortInfo>
#include <QWidget>
#include <QListWidget>
#include <QGroupBox>
#include <QPushButton>
#include <QRadioButton>
#include "tslib.h"
#include "stepList.h"
#include "plugin.h"
#include "QLineEdit"
#include "guidefs.h"

class T_win05 : public QWidget
{
    Q_OBJECT

    QGridLayout *myLayout;
    hwinf *HWaccess;
    uint16_t myNextStep;
    uint8_t myStep;
    QLabel *lab1;
    QLabel *lab2;
    QLabel *lab3;
    QTimer *myTO;

    QPushButton *PB_lockPwr;
    QPushButton * PB_uplockForw;
    QPushButton *PB_uplockStop;
    QPushButton *PB_uplockRev;
    QPushButton *PB_lowlockForw;
    QPushButton *PB_lowlockStop;
    QPushButton *PB_uplockOpen;
    QPushButton *PB_uplockClos;
    QPushButton *PB_lowlockOpen;
    QPushButton *PB_vaultDoor;
    QPushButton *PB_siren;

    QLabel *LEDpwrOn;
    QLabel *EncDoorUp;
    QLabel *EncDoorMid;
    QLabel *EncBillBox;
    QLabel *EncCoinBox;
    QLabel *EncDoorDn;
    QLabel *lockbarContactUU;
    QLabel *lockbarContactUD;
    QLabel *lockbarContactDU;
    QLabel *LedUdoorIsOpen;
    QLabel *LedUdoorIsClosed;
    QLabel *LedLdoorIsOpen;

    QLineEdit   *showSignals;
    QTimer      *timerClrDisp;

public:
    explicit T_win05(hwinf *HWaccess = nullptr, QWidget *parent = nullptr);
    bool work_ini(uint16_t *nextScreen, uint8_t *useNavi);
        // useNavi=0: no change
        // bit0,1: enable/disable button "next"
        // bit2,3: enable/disable button "home"
        // bit4,5: enable/disable button "back"
    bool working (uint16_t *nextScreen, uint8_t *useNavi);
    ~T_win05();

private slots:
    void Nav_back(void);
    void Nav_home(void);
    void Nav_next(void);
/* nur 2020:
    void ua_ulu(void);
    void ua_uld(void);
    void ua_uls(void);
    void ua_llu(void);
    void ua_lls(void);
*/
    void ua_osd(void);
//    void ua_csd(void);
    void ua_obd(void);
    void ua_vd(void);
    void switchPwr(void);
    void switchSiren(void);

    void door_slotUpOpen(void);
    void door_slotLowOpen(void);
    void door_slotBoxOut(void);
    void door_slotBoxIn(void);
    void door_slotCBin_AllClosed(void);
    void door_slotAllClosed(void);
    void door_slotClrSig(void);

};

#endif












