#ifndef WIN15_BNA_H
#define WIN15_BNA_H

#include <QVBoxLayout>
#include <QHBoxLayout>
#include <QGridLayout>
#include <QObject>
#include <QTimer>
#include <QDebug>
#include <QScrollBar>
#include <QPlainTextEdit>
#include <QComboBox>
#include <QLabel>
#include <QScrollArea>
#include <QSerialPortInfo>
#include <QWidget>
#include <QListWidget>
#include <QGroupBox>
#include <QPushButton>
#include <QRadioButton>
#include "tslib.h"
#include "stepList.h"
#include "plugin.h"
#include "guidefs.h"

class T_win15 : public QWidget
{
    Q_OBJECT

    QGridLayout *myLayout;
    QHBoxLayout *myH0layer;
    QVBoxLayout *myVlayer_left;
    QVBoxLayout *myVlayer_midd;
    QVBoxLayout *myVlayer_right;

    hwinf *HWaccess;
    uint16_t myNextStep;
    uint8_t myStep;
    QLabel *lab1, *lab2, *lab3, *lab4, *lab5;
    QTimer *myTO;

    QPushButton *pb_powerOn, *pb_sendDefault, *pb_only10_5, *pb_only5;
    QTextEdit *showDynamics, *showStatics, *showStacker;
    QPushButton *pb_startPay, *pb_stopPay;

    void displayDynamics(void);
    void displayStacker(void);
    void displayStatics(void);

    bool paymentStarted;

public:
    explicit T_win15(hwinf *HWaccess = nullptr, QWidget *parent = nullptr);
    bool work_ini(uint16_t *nextScreen, uint8_t *useNavi);
        // useNavi=0: no change
        // bit0,1: enable/disable button "next"
        // bit2,3: enable/disable button "home"
        // bit4,5: enable/disable button "back"
    bool working (uint16_t *nextScreen, uint8_t *useNavi);
    ~T_win15();

public slots:
    void Nav_back(void);
    void Nav_home(void);
    void Nav_next(void);
    void slot_powerOn(void);
    void slot_sendDef(void);
    void slot_send10_5(void);
    void slot_send5(void);
    void slot_start(void);
    void slot_stop(void);




};

#endif
