#ifndef WIN16_H
#define WIN16_H

#include <QVBoxLayout>
#include <QHBoxLayout>
#include <QGridLayout>
#include <QObject>
#include <QTimer>
#include <QDebug>
#include <QScrollBar>
#include <QPlainTextEdit>
#include <QComboBox>
#include <QLabel>
#include <QScrollArea>
#include <QSerialPortInfo>
#include <QWidget>
#include <QListWidget>
#include <QGroupBox>
#include <QPushButton>
#include <QRadioButton>
#include "tslib.h"
#include "stepList.h"
#include "plugin.h"
#include "guidefs.h"

class T_win16 : public QWidget
{
    Q_OBJECT

    //QGridLayout *myLayout;
    QHBoxLayout *myH0layer;
    QVBoxLayout *myVlayer_left;
    QVBoxLayout *myVlayer_midd;
    QVBoxLayout *myVlayer_right;

    hwinf *HWaccess;
    uint16_t myNextStep;
    uint8_t myStep;
    QLabel *lab1;
    QLabel *lab2;
    QLabel *lab3;
    QLabel *lab4;
    QTimer *myTO;
    QListWidget *win16_showErrors, *win16_showDoors;
    QPushButton *pb1, *pb2, *pb3;
    void showErrAndWarn(void);
    void showDoorState(void);

public:
    explicit T_win16(hwinf *HWaccess = nullptr, QWidget *parent = nullptr);
    bool work_ini(uint16_t *nextScreen, uint8_t *useNavi);
        // useNavi=0: no change
        // bit0,1: enable/disable button "next"
        // bit2,3: enable/disable button "home"
        // bit4,5: enable/disable button "back"
    bool working (uint16_t *nextScreen, uint8_t *useNavi);
    ~T_win16();

private slots:
    void Nav_back(void);
    void Nav_home(void);
    void Nav_next(void);
    void Button1Clicked(void);
    void Button2Clicked(void);
    void Button3Clicked(void);



};

#endif
